import 'rule.dart';

class Errors {
  const Errors(
    this.value,
  );

  final List<Error> value;

  factory Errors.ofRuleAndLines({
    required Rule rule,
    required String filePath,
    required List<String> lines,
  }) {
    final result = <Error>[];
    for (final regExp in rule.notAllowImportRegExps) {
      final resultLines = <ErrorLine>[];
      for (var i = 0; i < lines.length; i++) {
        final line = lines[i];
        if (regExp.hasMatch(line)) {
          resultLines.add(ErrorLine(i + 1, line));
        }
      }
      if (resultLines.isNotEmpty) {
        result.add(Error(rule, filePath, regExp, resultLines));
      }
    }
    return Errors(result);
  }
}

class Error {
  const Error(
    this.rule,
    this.filePath,
    this.notArrowRegExp,
    this.lines,
  );

  final Rule rule;
  final String filePath;
  final RegExp notArrowRegExp;
  final List<ErrorLine> lines;
}

class ErrorLine {
  const ErrorLine(
    this.number,
    this.value,
  );

  final int number;
  final String value;
}
